def K8S_TEMPLATE = """
apiVersion: v1
kind: Pod
spec:
  containers:
  - name: ubuntu
    image: core.harbor.fwc.dc.kubernetes.vm/library/ubuntu:latest
    command:
    - cat
    tty: true
"""

pipeline {
    agent any
    environment {
        PLACEHOLDER = "changeme"
    }
    stages {
        stage('Initialise Agent') {
            agent { kubernetes yaml: "${K8S_TEMPLATE}" }
            stages {
                stage('Install OS dependencies') {
                    steps {
                        container('ubuntu') {
                            sh """
                            # Install dependencies
                            apt update -y && apt install -y git make python3 python3-pip

                            # Sync all submodules
                            git config --global --add safe.directory `pwd`
                            git config --global --add safe.directory `pwd`/.make
                            git submodule update --init --force --recursive
                            """
                        }
                    }
                }
                stage('Initialise workspace') {
                    steps {
                        container('ubuntu') {
                            // Test make integration
                            sh 'make make'
                        }
                    }
                }
            }
        }
    }
}